MBSRTOWCS(3)

NAME
mbsrtowcs, mbsnrtowcs, _mbsrtowcs_r, _mbsnrtowcs_r - convert a character string to a wide-character string

SYNOPSIS

#include <wchar.h>

size_t mbsrtowcs(wchar_t *__restrict dst, const char **__restrict src, size_t len, mbstate_t *__restrict ps);

#include <wchar.h>

size_t _mbsrtowcs_r(struct _reent *ptr, wchar_t *dst, const char **src, size_t len, mbstate_t *ps);

#include <wchar.h>

size_t mbsnrtowcs(wchar_t *__ restrict dst, const char **__restrict src, size_t nms, size_t len, mbstate_t *__restrict ps);

#include <wchar.h>

size_t _mbsnrtowcs_r(struct _reent *ptr, wchar_t *dst, const char **src, size_t nms, size_t len, mbstate_t *ps);

DESCRIPTION

The mbsrtowcs function converts a sequence of multibyte characters pointed to indirectly by src into a sequence of corresponding wide characters and stores at most len of them in the wchar_t array pointed to by dst, until it encounters a terminating null character ('\0').

If dst is NULL, no characters are stored.

If dst is not NULL, the pointer pointed to by src is updated to point to the character after the one that conversion stopped at. If conversion stops because a null character is encountered, *src is set to NULL.

The mbstate_t argument, ps, is used to keep track of the shift state. If it is NULL, mbsrtowcs uses an internal, static mbstate_t object, which is initialized to the initial conversion state at program startup.

The mbsnrtowcs function behaves identically to mbsrtowcs, except that conversion stops after reading at most nms bytes from the buffer pointed to by src.

RETURNS

The mbsrtowcs and mbsnrtowcs functions return the number of wide characters stored in the array pointed to by dst if successful, otherwise it returns (size_t)-1.

PORTABILITY

mbsrtowcs is defined by the C99 standard. mbsnrtowcs is defined by the POSIX.1-2008 standard.